package de.intevation.flys.artifacts.model.sq;

import java.util.Map;

public class Measurement
{
    protected Map<String, Object> data;

    public Measurement() {
    }

    public Measurement(Map<String, Object> data) {
        this.data = data;
    }

    protected double get(String name) {
        Number value = (Number)data.get(name);
        return value != null ? value.doubleValue() : Double.NaN;
    }

    public double S_SS() {
        return get("TSAND");
    }

    public double S_SF() {
        return get("TSCHWEB") - get("TSAND");
    }

    public double Q() {
        return get("Q");
    }

    public double TOTAL_BL() {
        // TODO: Implement me!
        return Double.NaN;
    }

    public double SAND() {
        // TODO: Implement me!
        return Double.NaN;
    }


    public double S_BL_S() {
        return SAND() * TOTAL_BL();
    }

    public double S_BL_FG() {
        // TODO: Implement me!
        return Double.NaN;
    }

    public double S_BL_CG() {
        // TODO: Implement me!
        return Double.NaN;
    }

    public double S_BL() {
        // TODO: Implement me!
        return Double.NaN;
    }

    public double S_BL_1() {
        return S_BL_S() + S_BL_FG() + S_BL_CG();
    }

    public double S_BL_2() {
        return S_SS() + S_BL_S() + S_BL_FG() + S_BL_CG();
    }

    public double SIEB(int i) {
        return get(String.format("SIEB%02d", i));
    }

    public double RSIEB(int i) {
        return get(String.format("RSIEB%02d", i));
    }

    public double REST() {
        return get("REST");
    }

    @Override
    public String toString() {
        return "Measurement: " + data;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf-8 :
